
'Frequenzmessung ohne Timer bis 40 kHz

$regfile = "m32def.dat"
$crystal = 11059200
$baud = 9600
$hwstack = 16
$swstack = 32
$framesize = 32

S1 Alias Pind.2
S2 Alias Pind.3
S3 Alias Pind.6
S4 Alias Pind.7


Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls
Locate 1 , 1
Lcd "AK Modul Bus"
Locate 2 , 1
Lcd "ES-M32"
Waitms 500


Config Timer1 = Counter , Prescale = 1 , Compare A = Toggle , Clear Timer = 1
Start Timer1
Pwm1a = 199                                                 'Xtal/2/(199+1) = 27,648 kHz, Testsignal


Dim N As Long
Dim F As Word
Dim F2 As Word
Dim D As Bit
Dim D2 As Bit

Do
  F = 0
  For N = 1 To 49125
    If Pinc.0 <> D Then                                     'Eingang C.0
      F = F + 1
      Toggle D
    Else
      F2 = F2 + 1
      Toggle D2
    End If
  Next N
  Cls
  Locate 1 , 1
  Lcd F                                                     'max 40 kHz
Loop



Dim F3 As Long

Do
  F = 0
  Timer0 = 0
  D = 1
  Start Timer0                                              'Eingang B.0
  For N = 1 To 92158
    D2 = Timer0.7
    If D2 < D Then
      F = F + 1
      D = D2
    Else
      F2 = F2 + 1
      D = D2
    End If
  Next N
  Stop Timer0
  D2 = Timer0.7
  If D2 = 0 Then
    If D = 1 Then F = F + 1
  End If

  F = F - 1
  F3 = F * 256
  F3 = F3 + Timer0
  Cls
  Locate 1 , 1
  Lcd F3                                                    '> 1 Mhz
Loop
